    001    /* ===========================================================
    002     * JFreeChart : a free chart library for the Java(tm) platform
    003     * ===========================================================
    004     *
    005     * (C) Copyright 2000-2007, by Object Refinery Limited and Contributors.
    006     *
    007     * Project Info:  http://www.jfree.org/jfreechart/index.html
    008     *
    009     * This library is free software; you can redistribute it and/or modify it
    010     * under the terms of the GNU Lesser General Public License as published by
    011     * the Free Software Foundation; either version 2.1 of the License, or
    012     * (at your option) any later version.
    013     *
    014     * This library is distributed in the hope that it will be useful, but
    015     * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
    016     * or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public
    017     * License for more details.
    018     *
    019     * You should have received a copy of the GNU Lesser General Public
    020     * License along with this library; if not, write to the Free Software
    021     * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301,
    022     * USA.
    023     *
    024     * [Java is a trademark or registered trademark of Sun Microsystems, Inc.
    025     * in the United States and other countries.]
    026     *
    027     * -----------------------------------------
    028     * StandardCategorySeriesLabelGenerator.java
    029     * -----------------------------------------
    030     * (C) Copyright 2005-2007, by Object Refinery Limited.
    031     *
    032     * Original Author:  David Gilbert (for Object Refinery Limited);
    033     * Contributor(s):   -;
    034     *
    035     * Changes
    036     * -------
    037     * 20-Apr-2005 : Version 1 (DG);
    038     * ------------- JFREECHART 1.0.x ---------------------------------------------
    039     * 03-May-2006 : Fixed equals() method (bug 1481102) (DG);
    040     *
    041     */
    042
    043    package org.jfree.chart.labels;
    044
    045    import java.io.Serializable;
    046    import java.text.MessageFormat;
    047
    048    import org.jfree.data.category.CategoryDataset;
    049    import org.jfree.util.PublicCloneable;
    050
    051    /**
    052     * A standard series label generator for plots that use data from
    053     * a {@link org.jfree.data.category.CategoryDataset}.
    054     */
    055    public class StandardCategorySeriesLabelGenerator implements
    056        CategorySeriesLabelGenerator, Cloneable, PublicCloneable, Serializable {
    057
    058        /** For serialization. */
    059        private static final long serialVersionUID = 4630760091523940820L;
    060
    061        /** The default item label format. */
    062        public static final String DEFAULT_LABEL_FORMAT = "{0}";
    063
    064        /** The format pattern. */
    065        private String formatPattern;
    066
    067        /**
    068         * Creates a default series label generator (uses
    069         * {@link #DEFAULT_LABEL_FORMAT}).
    070         */
    071        public StandardCategorySeriesLabelGenerator() {
    072            this(DEFAULT_LABEL_FORMAT);
    073        }
    074
    075        /**
    076         * Creates a new series label generator.
    077         *
    078         * @param format  the format pattern (<code>null</code> not permitted).
    079         */
    080        public StandardCategorySeriesLabelGenerator(String format) {
    081            if (format == null) {
    082                throw new IllegalArgumentException("Null 'format' argument.");
    083            }
    084            this.formatPattern = format;
    085        }
    086
    087        /**
    088         * Generates a label for the specified series.
    089         *
    090         * @param dataset  the dataset (<code>null</code> not permitted).
    091         * @param series  the series.
    092         *
    093         * @return A series label.
    094         */
    095        public String generateLabel(CategoryDataset dataset, int series) {
    096            if (dataset == null) {
    097                throw new IllegalArgumentException("Null 'dataset' argument.");
    098            }
    099            String label = MessageFormat.format(this.formatPattern,
    100                    createItemArray(dataset, series));
    101            return label;
    102        }
    103
    104        /**
    105         * Creates the array of items that can be passed to the
    106         * {@link MessageFormat} class for creating labels.
    107         *
    108         * @param dataset  the dataset (<code>null</code> not permitted).
    109         * @param series  the series (zero-based index).
    110         *
    111         * @return The items (never <code>null</code>).
    112         */
    113        protected Object[] createItemArray(CategoryDataset dataset, int series) {
    114            Object[] result = new Object[1];
    115            result[0] = dataset.getRowKey(series).toString();
    116            return result;
    117        }
    118
    119        /**
    120         * Returns an independent copy of the generator.
    121         *
    122         * @return A clone.
    123         *
    124         * @throws CloneNotSupportedException if cloning is not supported.
    125         */
    126        public Object clone() throws CloneNotSupportedException {
    127            return super.clone();
    128        }
    129
    130        /**
    131         * Tests this object for equality with an arbitrary object.
    132         *
    133         * @param obj  the other object (<code>null</code> permitted).
    134         *
    135         * @return A boolean.
    136         */
    137        public boolean equals(Object obj) {
    138            if (obj == this) {
    139                return true;
    140            }
    141            if (!(obj instanceof StandardCategorySeriesLabelGenerator)) {
    142                return false;
    143            }
    144            StandardCategorySeriesLabelGenerator that
    145                    = (StandardCategorySeriesLabelGenerator) obj;
    146            if (!this.formatPattern.equals(that.formatPattern)) {
    147                return false;
    148            }
    149            return true;
    150        }
    151
    152    }